# NOTE: Derived from blib/lib/Config/Framework.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Config::Framework;

#line 324 "blib/lib/Config/Framework.pm (autosplit into blib/lib/auto/Config/Framework/AlertAdmin.al)"
## AlertAdmin #####################################
sub AlertAdmin {
	my ($self, %p) = @_;
	
	#Message is requred
	exists($p{'Message'}) || do {
		$self->{'errstr'} = "AlertAdmin: 'Message' is a required option";
		return (undef);
	};
	
	#default 'To' is the admin
	exists($p{'To'}) || do {
		push (@{$p{'To'}}, $self->{'admin'});
	};
	
	#fix stringy 'To''s to work with arrayified ones
	if ((exists($p{'To'})) && (ref($p{'To'}) ne "ARRAY")){
		my $temp = $p{'To'};
		delete($p{'To'});
		push(@{$p{'To'}}, $temp);
	}
	
	#if we're in debug mode, just print the message to stdout and be done
	if ($self->{'debug'}){
		print $p{'Message'}, "\n";
		return (1);
	}
	
	#open sendmail pipe
	open (SENDMAIL, "|$self->{sendmail} -oi -t -fnobody") || do {
		#can't open sendmail, spew message to v_root/var/last_resort.log
		open (LAST_RESORT, ">>$self->{'v_root'}/var/log/last_resort.log") || do {
			print "AlertAdmin: can't open sendmail or last_resort.log $p{'Message'}\n";
			return (undef);
		};
		my $time = time();
		print LAST_RESORT "[$time]: can't open sendmail! $p{'Message'}\n";
		close (LAST_RESORT);
	};
	
	#give sendmail the message
	print SENDMAIL "From: nobody ($self->{'program'})\n";
	print SENDMAIL "To: ", join (', ', @{$p{'To'}}), "\n";
	print SENDMAIL "Subject: Auto-generated Alert from: $self->{program}\n";
	print SENDMAIL "Reply-To: nobody\n";
    print SENDMAIL "Errors-To: nobody\n\n";
    print SENDMAIL "\n\n";
    print SENDMAIL $p{Message}, "\n";
    
    #spew the user's environment if specified
    if ($p{ENV}){
		print SENDMAIL "\n[ENV] --------------------------------------------\n";
        foreach (keys %ENV){ print SENDMAIL "[$_]: $ENV{$_}\n"; }
    }
    
    #send the message 
    close (SENDMAIL);
    
    #if specified, log the message as well
    if ($p{'Log'}){ $self->Log(%p); }
    
    #if specified, die as well
    if ($p{'Die'}){ die ($p{'Message'}, "\n"); }
    
    #shiver me timbers, maytee
    return (1);
}

# end of Config::Framework::AlertAdmin
1;
