# NOTE: Derived from blib/lib/Config/Framework.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Config::Framework;

#line 185 "blib/lib/Config/Framework.pm (autosplit into blib/lib/auto/Config/Framework/LoadConfig.al)"
## LoadConfig #####################################
sub LoadConfig {
	my ($self, %p) = @_;
	
	#File is a required option
	exists($p{'File'}) || do {
		$self->{'errstr'} = "LoadConfig: 'File' is a required option";
		return (undef);
	};
	
	#find the file
	(-e $p{'File'}) || do {
		#if it exists under config_loc use that
		if (-e "$self->{'v_root'}/$self->{'config_loc'}/$p{'File'}"){
			$p{'File'} = "$self->{'v_root'}/$self->{'config_loc'}/$p{'File'}";
		#otherwise if it exists under the FrameworkDir, use that
		}elsif (-e "$self->{'FrameworkDir'}/$p{'File'}"){
			$p{'File'} = "$self->{'FrameworkDir'}/$p{'File'}";
		#other-otherwise if it exists in the user's home directory, use that
		}elsif (-e "$ENV{'HOME'}/$p{'File'}"){
			$p{'File'} = "$ENV{'HOME'}/$p{'File'}";
		#else there's a problem
		}else{
			$self->{'errstr'} = "LoadConfig: can't find the file $p{'File'}";
			return (undef);
		}
	};
	
	#load it up
	my $data = $self->LoadXMLConfig(%p) || do {
		$self->{'errstr'} = "LoadConfig: $self->{'errstr'}";
		return (undef);
	};
	
	#if the file dosen't define a config namespace ...
	exists($data->{'configNamespace'}) || do {
		#if there is a user-defined namespace, use that
		if (exists($p{'configNamespace'})){
			$data->{'configNamespace'} = $p{'configNamespace'};
		}else{
			$self->{'errstr'} = "LoadConfig: $p{'File'} does not define a 'configNamespace', and none has been ";
			$self->{'errstr'}.= "specified with this function call. I don't know where to put this data!";
			return (undef);
		}
	};
	
	#if theres a parent namespace specified, put it under there
	#otherwise stash it in the object under it's own namespace
	if (exists($p{'Parent'})){
		$self->{$p{'Parent'}}->{$data->{'configNamespace'}} = $data;
	}else{
		$self->{$data->{'configNamespace'}} = $data;
	}
	
	#keep a map so that WriteConfig can write by namespace instead of filename
	$self->{'_ConfigMap'}->{$data->{'configNamespace'}} = $p{'File'};
	
	#load any child configs
	if (($self->{'LoadChildren'}) && exists($data->{'children'})){
		foreach (@{$data->{'children'}}){
			$self->LoadConfig(
				File	=> $_,
				Parent	=> $data->{'configNamespace'}
			) || do {
				$self->{'errstr'} = "LoadConfig: failed to load child config ($_) for parent ($data->{'configNamespace'}) $self->{'errstr'}";
				return (undef);
			};
		}
	}
	
	#'tis all good
	return (1);
}

# end of Config::Framework::LoadConfig
1;
